-- HOLDS ALL GAME CONTROLS AND SOME FUNCTIONS RELATING TO THEM

-- interaction tables used by the menu system

pretable = {
	{x=260,y=0,w=15,h=24,action={"settings","resolution",-1}},
	{x=280,y=0,w=15,h=24,action={"settings","resolution",1}},
	{x=125,y=25,w=24,h=24,action={"settings","fullscreen"}},
	{x=250,y=49,w=24,h=24,action={"pre","starttoggle"}},
	{x=5,y=96,w=150,h=28,action={"pre","launch"}},

}

-- currenttable to draw menu style interactions from



-- click area detection functions for menu code
function nearestMenu(x,y,t)
	return nearestestui(x,y,t)
end

function nearestestui(x,y,t)
	for i,v in ipairs(t) do
		if checkCollision(x,y,1,1,v.x,v.y,v.w,v.h) == true then
			id = i
		end
	end
	return id
end

--input library for mousepresses
function love.mousepressed(x,y,button)
	if button == "l" then
		typedinput = false
		mouseAction(x,y,1)
	end
	if button == "r" then
		typedinput = false
		mouseAction(x,y,2)
	end
	if button == "wu" then
		mouseAction(x,y,3)
	end
	if button == "wd" then
		mouseAction(x,y,4)
	end
	if button == "m" then
		mouseAction(x,y,5)
	end
end

-- HUD DETECTION CODE


--SUPERFUNCTION
--controls all of the mouse actions within the editor
function mouseAction(x,y)
	--checking if the mouse is on any objects.
	local n = nearestMenu(x,y,state[2])
	--if it isn't it will turn up null and this section wont run
	if n ~= null then
		if state[2][n].action[1] == "pre" then
			if state[2][n].action[2] == "starttoggle" then
				-- changing whether premenu shows or not
				if settings.premenu then
					settings.premenu = false
				else
					settings.premenu = true
				end
			elseif state[2][n].action[2] == "launch" then
				-- launching the game from the premenu
				
			end
		elseif state[2][n].action[1] == "settings" then
			if state[2][n].action[2] == "fullscreen" then
				if settings.fullscreen then
					settings.fullscreen = false
				else
					settings.fullscreen = true
				end
			elseif state[2][n].action[2] == "resolution" then
				if settings.currentres[3] + state[2][n].action[3] <= #resolutions and settings.currentres[3] + state[2][n].action[3] > 0 then
					settings.currentres[3] = settings.currentres[3] + state[2][n].action[3]
				elseif settings.currentres[3] + state[2][n].action[3] > #resolutions then
					settings.currentres[3] = 1
				elseif settings.currentres[3] + state[2][n].action[3] < 1 then
					settings.currentres[3] = #resolutions
				end
				settings.currentres = {resolutions[settings.currentres[3] ].width,resolutions[settings.currentres[3] ].height,settings.currentres[3]}
			end
		end
	end
	n = nil
end

-- keypressed inputs
-- typed input toggles whether you are writing or using shortcuts
function love.keypressed(key,unicode)
	if key == "f2" then
		sip.power()
		debug = false
	elseif not sip.info.power then
		if key == "f1" then
			if debug then
				debug = false
			else
				debug = true
			end
		end
	else
		if shifton then
			sip.input(string.upper(key))
		else
			sip.input(key)
		end
	end

end

-- function that checks if a key is down every game tickyeah
shifton = null
function keydown()
	if love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift") then
		shifton = true
	else
		shifton = false
	end
end

-- function that makes sure the key your pressing is an okay typedinput
function typedinputcheck(item)
	local temp = false
	local possibleinputs = {" ","1","2","3","4","5","6","7","8","9","0","q","w","e","r","t","y","u","i","o","p","a","s","d","f","g","h","j","k","l","z","x","c","v","b","n","m"}
	
	for i,v in ipairs(possibleinputs) do
		if item == v then
			temp = true
		end
	end
	
	return temp
end



--SUPERFUNCTION
--controls all of the actions from keyboard inputs from both
--keypressed and keydown
--x and y not just used for x and y positions
--but also for x and y arguments or information for ease of customisation of this table
function keyAction(action,x,y)

end










