require "ow_rope"

function love.load()
	font14 = love.graphics.newFont("Lekton-Bold.ttf",14)
	font24 = love.graphics.newFont("Lekton-Bold.ttf",24)
	love.graphics.setFont(font24)
	
	resolutions = love.graphics.getModes()
	table.sort(resolutions, function(a, b) return a.width*a.height < b.width*b.height end)
	screen = {love.graphics.getWidth(),love.graphics.getHeight()}
	debug = false
	tooltip = null

	ropeRead("ow_illusion.lua")
	ropeRead("ow_sip.lua")
	ropeRead("ow_camera.lua")
	ropeRead("display.lua")
	ropeRead("control.lua")
	ropeRead("engine.lua")
	
	state = {"pre",pretable}
	
	ropeLoad("obscureworlds/sand","settings.lua")
end

function love.update(dt)
	variableupdate(dt)

end

function love.draw()
	display.draw()
	
	if debug then
		if state[2] ~= null then
			love.graphics.setColor(200,200,200,100)
			for i = 1,#state[2] do
				love.graphics.rectangle("fill",state[2][i].x,state[2][i].y,state[2][i].w,state[2][i].h)
			end
			love.graphics.setColor(255,255,255,255)
		end
	
		local x,y = mX,mY
		if mX + 155 > screen[1] then
			x = mX-160
		end
		if mY + 25 > screen[2] then
			y = mY - 30
		end
	
		love.graphics.setFont(font14)
		love.graphics.setColor(0,0,0,100)
		love.graphics.rectangle("fill",x+5,y+5,150,25)
		love.graphics.setColor(255,255,255,255)
		love.graphics.print("Mpos="..mX.." : "..mY,x+10,y+5)
		love.graphics.print("fps="..love.timer.getFPS(),x+10,y+17)
	elseif not debug and tooltip ~= null then
		local x,y = mX,mY
		if mX + 160 > screenWidth then
			x = mX-165
		end
		if mY + (20+(14*(font14:getWidth(tooltip)/150))) > screenHeight then
			y = mY - (20+(14*(font14:getWidth(tooltip)/150)))
		end
		love.graphics.setFont(font14)
		love.graphics.setColor(0,0,0,100)
		love.graphics.rectangle("fill",x+5,y+5,160,20+(14*(font14:getWidth(tooltip)/150)))
		love.graphics.setColor(255,255,255,255)
		love.graphics.printf(tooltip,x+10,y+10,150,"left")
		love.graphics.setFont(font24)
	elseif not debug and sip.info.power then
		sip.display()
	end
end