--[[
LICENCE DETAILS: ZLIB LICENCE

Copyright (c) <2011> <Lewis Pearce>

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

   1. The origin of this software must not be misrepresented; you must not
   claim that you wrote the original software. If you use this software
   in a product, an acknowledgment in the product documentation would be
   appreciated but is not required.

   2. Altered source versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

   3. This notice may not be removed or altered from any source
   distribution.
]]

---- EXAMPLE OF HOW TO USE THIS TABLE
----
---- require "ow_rope.lua"
---- libraries = {"illusion.lua"}
---- ropeLoad("exampledirectory","examplesavefile")
----


function ropeLoad(directory,savefile)
	math.randomseed(os.time())	
	
	-- you can put all the libraries your game loads here
	
	love.filesystem.setIdentity(directory)
	-- >>>
	if love.filesystem.exists(savefile) then 
		ropeRead(savefile)
	elseif not love.filesystem.exists(savefile) then
	-- place what you want the default settings for this file here
		love.filesystem.mkdir("sandbox")
		love.filesystem.mkdir("challenge")
	
		settings = {
			fullscreen=false,
			premenu = true,
			currentres = {800,600,1},
			canvases = true,
			volume = 0.3,
		}
		--use this bit to save in other ways
		love.filesystem.write(savefile,"settings="..ropeBurn(settings))
	end
	
	-- <<<
	-- if you need more files copy and paste the stuff between >>> and <<<
	-- modify savefile and directory so they become savefile1 and directory1
	-- then add them to the box next to "ropeLoad" and where you call it in the love.load
end

-- tables must be compatible with ropeburn

function ropeBurn(t)
	local data = {}
	if type(t) == "number" then
		return t
	elseif type(t) == "boolean" then
		if t then
			return "true"
		elseif not t then
			return "false"
		end
	elseif type(t) == "string" then
		return t
	elseif type(t) == "table" then
		local data = {}
		table.insert(data,"{")
		for k,v in pairs(t) do
			if type(k) ~= "number" then
				local k_info = ropeBurn(k)
				local v_info = ropeBurn(v)
				table.insert(data,k_info)
				table.insert(data,"=")
				table.insert(data,v_info)
				table.insert(data,",")
			elseif type(k) == "number" and type(v) == "table" then
				local k_info = ropeBurn(k)
				local v_info = ropeBurn(v)
				table.insert(data,v_info)
				table.insert(data,",")
			elseif type(k) == "number" and type(v) == "number" then
				local k_info = ropeBurn(k)
				local v_info = ropeBurn(v)
				table.insert(data,v_info)
				table.insert(data,",")
			end
		end
		table.insert(data,"}")
		return table.concat(data)
	end
end

function ropeRead(item)
	love.filesystem.load(item)()
end

function ropeReadandReturn(item)
	return love.filesystem.load(item)()
end